<?php
if (!defined("IN_FUSION")) { header("Location:../../index.php"); exit; }
openside("ministats");
// MINISTATS - A tiny stats system for PHPFusion/Mfusion.
// It uses just a table, it not use recursive loops trough database (just 1 call!) and it's totally self contained.
// programmed by amra (www.sumotoy.com - www.sumotoy.net - www.sumotoy.it - www.sumotoy.org)
// If you use in other projects you MUST LEAVE INTACT COMMENTS and send a email to info@sumotoy.com
// Peace and Love
// USAGE AND INSTALLATION
// You need this image in your images folder : statbar.gif
// You need a table called ministats. Use this in your mysql administrator
//**************************************************************************
// version: 1.0 	: First release
// version: 1.01 	: Fixed a small bug (substituted round with ceil)
// version: 1.02 	: compatible w IE
// version: 1.03 	: added visits counts for each bar
// version: 1.04 	: minor fix to id table
//*************************************************************************

function ministats(){
$now = time();
// has a cookie?
if (!isset($_COOKIE['ministats'])){
	$result = dbquery("INSERT INTO ".DB_PREFIX."ministats (id, timestamp) VALUES ('', '".$now."')");
	header("P3P: CP='IDC DSP COR CURa ADMa OUR IND PHY ONL COM STA'");
	setcookie("ministats", "yes", $now+3600, "/", "", "0");	//24h		
} 
// how many visitors in 24 hours?
$result = dbquery("SELECT * FROM ".DB_PREFIX."ministats WHERE timestamp>'".($now-86400)."' AND timestamp<='".$now."'");
if($result != 0){
	$out = '<table cellspacing="0" cellpadding="0" width="150" align="center"><tr>';
	$visitors = array();// visitors container
	$arrax = array();// db values container
	$rows = 0;// total visitors
	// now get dbdata and put in array
	while ($data = dbarray($result)){
		$arrax[$rows] = $data['timestamp'];// put timestamp in array
		$rows++;// increment total counter
	}
	// 24 hours loop
	for ($i=23;$i>=0;$i--){
		$out .= "<td align='center' valign='bottom' width='6'>";
		$visitors[$i] = 0;
		//now loop through db results

		for($db=0;$db<$rows;$db++){
			if(($arrax[$db] > ($now-(($i+1)*3600)) && $arrax[$db] <= ($now-($i*3600)))) $visitors[$i]++;//increment
		}		
			if($rows>0){
				$height = ceil(((100/$rows)*$visitors[$i])+1);// bar height
			} else {
				$height = 1;// bar height
			}
		if ($i == 0){
			$title = "now - ".$visitors[$i]." visits";
		} else {
			$title = $i." hours ago - ".$visitors[$i]." visits";
		}			
			$out .= "<img src='".INFUSIONS."ministats_panel/images/statbar.gif' height='".$height."' width='6' alt='' title='".$title."'><br></td>";// bar
	}
	unset($arrax);
	unset($visitors);
	$out .= "</tr></table>";
	// time to clean
  $result = dbquery("DELETE FROM ".DB_PREFIX."ministats WHERE timestamp<'".mktime(0,0,0,date("m"),1,date("Y"))."'");
  return $out;
} else {
	return "no results<br>";
}
}
// TO get the stats you just need 1 command: 
// echo ministats();
// That's all! Function does all the stuff for you.
// happy coding

echo ministats();
closeside();
?>